%global momorel 6

Name:           rpcbind
Version:        0.1.4
Release:	%{momorel}m%{?dist}
Summary:        Universal Addresses to RPC Program Number Napper
Group:          System Environment/Daemons
License:        GPL
URL:            http://nfsv4.bullopensource.org

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Source0: http://nfsv4.bullopensource.org/tarballs/rpcbind/rpcbind-%{version}.tar.bz2 
NoSource: 0
Source1: rpcbind.init

Requires: glibc-common >= 2.6
#Requires: setup >= 2.6.4-1
#Conflicts: man-pages < 2.43-12
BuildRequires: automake, autoconf, libtool
BuildRequires: libtirpc-devel quota perl tcp_wrappers-devel
Requires(pre): shadow-utils
Requires(post): chkconfig

Provides: portmap = 4.0
Obsoletes: portmap

Patch1: rpcbind-0.1.4-compile.patch
Patch2: rpcbind-0.1.4-debug.patch
Patch3: rpcbind-0.1.4-warmstarts.patch
Patch4: rpcbind-0.1.4-rpcuser.patch
Patch5: rpcbind-0.1.4-iff_up.patch
Patch6: rpcbind-0.1.4-libwrap.patch
Patch7: rpcbind-0.1.4-localaddr.patch

%description
The rpcbind utility is a server that converts RPC program numbers into
universal addresses.  It must be running on the host to be able to make
RPC calls on a server on that machine.

%prep
%setup -q

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
# 240873: rpcbind segfaults on startup - ipv6 related
%patch5 -p1
# 248284: rpcbind ignores libwrap files
%patch6 -p1
# 358621: rpcbind-0.1.4-8.fc7 breaks NFS
%patch7 -p1

%build
%ifarch s390 s390x
PIE="-fPIE"
%else
PIE="-fpie"
%endif
export PIE

RPCBUSR=rpc
RPCBDIR=/var/lib/rpcbind
CFLAGS="`echo $RPM_OPT_FLAGS $ARCH_OPT_FLAGS $PIE`"

autoreconf -fisv
%configure CFLAGS="$CFLAGS" LDFLAGS="-pie" \
    --enable-warmstarts \
    --with-statedir="$RPCBDIR" \
    --with-rpcuser="$RPCBUSR" \
    --enable-libwrap \
    --enable-debug

%make

%install
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

mkdir -p %{buildroot}/sbin
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_initscriptdir}
mkdir -p %{buildroot}%{_mandir}/man8
mkdir -p %{buildroot}/var/lib/rpcbind

install -m 755 src/rpcbind %{buildroot}/sbin
install -m 755 src/rpcinfo %{buildroot}%{_sbindir}
install -m 644 man/rpcbind.8 %{buildroot}%{_mandir}/man8
install -m 644 man/rpcinfo.8 %{buildroot}%{_mandir}/man8
install -m 755 ${RPM_SOURCE_DIR}/rpcbind.init %{buildroot}%{_initscriptdir}/rpcbind

# stop auto start
perl -p -i -e 's@^# chkconfig: (\d+) (\d+) (\d+)$@# chkconfig: - $2 $3@' %{buildroot}%{_initscriptdir}/rpcbind

%clean
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%pre
# if the rpc uid and gid is left over from the portmapper
# remove both of them.
/usr/sbin/userdel  rpc 2> /dev/null || :
/usr/sbin/groupdel rpc 2> /dev/null || : 

# Now re-add the rpc uid/gid
/usr/sbin/groupadd -g 32 rpc > /dev/null 2>&1
/usr/sbin/useradd -l -c "Rpcbind Daemon" -d /var/lib/rpcbind -g 32 \
    -M -s /sbin/nologin -u 32 rpc > /dev/null 2>&1

%post 
/sbin/chkconfig --add %{name}

%preun
if [ $1 -eq 0 ]; then
    /sbin/service rpcbind stop > /dev/null 2>&1
    /sbin/chkconfig --del %{name}
    /usr/sbin/userdel  rpc 2>/dev/null || :
    /usr/sbin/groupdel rpc 2>/dev/null || :
    rm -rf /var/lib/rpcbind
fi

%postun
if [ "$1" -ge "1" ]; then
    /sbin/service rpcbind condrestart > /dev/null 2>&1
fi

%files
%defattr(-,root,root)
%doc AUTHORS ChangeLog README
/sbin/rpcbind
%{_sbindir}/rpcinfo
%{_mandir}/man8/*
%config %{_initscriptdir}/rpcbind

%dir %attr(700,rpc,rpc) /var/lib/rpcbind

%changelog
* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.1.4-6m)
- rebuild against gcc43

* Wed Feb 13 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (0.1.4-5m)
- %%NoSource -> NoSource

* Tue Dec 18 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.1.4-4m)
- sync with fc-devel (rpcbind-0_1_4-12_fc9)
--* Mon Dec 17 2007 Steve Dickson <steved@redhat.com> 0.1.4-12
--- Changed is_loopback() and check_access() see if the calling
--  address is an address on a local interface, just not a loopback
--  address (bz 358621).
--* Wed Oct 17 2007 Steve Dickson <steved@redhat.com> 0.1.4-11
--- Reworked logic in initscript so the correct exit is 
--  used when networking does not exist or is set up
--  incorrectly.
--* Tue Oct 16 2007 Steve Dickson <steved@redhat.com> 0.1.4-10
--- Corrected a typo in the initscript from previous 
--  commit.
--* Mon Oct 15 2007 Steve Dickson <steved@redhat.com> 0.1.4-9
--- Fixed typo in Summary (bz 331811)
--- Corrected init script (bz 247046)
--* Sat Sep 15 2007 Steve Dickson <steved@redhat.com> 0.1.4-8
--- Fixed typo in init script (bz 248285)
--- Added autoconf rules to turn on secure host checking
--  via libwrap. Also turned on host check by default (bz 248284)
--- Changed init script to start service in runlevel 2 (bz 251568)
--- Added a couple missing Requires(pre) (bz 247134)

* Wed Jun 20 2007 Mitsuru Shimamura <smbd@momonga-linux.org>
- (0.1.4-3m)
- stop auto start

* Mon May 28 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.1.4-2m)
- sync with fc-devel (rpcbind-0_1_4-7_fc8)
--* Fri May 25 2007 Steve Dickson <steved@redhat.com> 0.1.4-7
--- Fixed condrestarts (bz 241332)
--* Tue May 22 2007 Steve Dickson <steved@redhat.com> 0.1.4-6
--- Fixed an ipv6 related segfault on startup (bz 240873)

* Sat May 19 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org> 
- (0.1.4-1m)
- import from fc-devel 0.1.4-5
